# MIZVAN.py Random Bitcoin Legacy compressed/uncompresses address and Segwit address. Check for Total Received Ammount 11/07/2021
# Good Luck and Happy Hunting. Made by mizogg.co.uk
# Donations 3M6L77jC3jNejsd5ZU1CVpUVngrhanb6cD
import itertools
from bit import *
from bit.format import bytes_to_wif
import random
import urllib.request
import atexit
import datetime
import os
import webbrowser
import PySimpleGUI as sg
from json import (load as jsonload, dump as jsondump)
from os import path
import json

start_time = datetime.datetime.now()


SETTINGS_FILE = path.join(path.dirname(__file__), r'settings_file.cfg')
DEFAULT_SETTINGS = {'theme': sg.theme()}
SETTINGS_KEYS_TO_ELEMENT_KEYS = {'theme': '-THEME-'}

def load_settings(settings_file, default_settings):
    try:
        with open(settings_file, 'r') as f:
            settings = jsonload(f)
    except Exception as e:
        sg.popup_quick_message(f'exception {e}', 'No settings file found... will create one for you', keep_on_top=True, background_color='red', text_color='white')
        settings = default_settings
        save_settings(settings_file, settings, None)
    return settings


def save_settings(settings_file, settings, values):
    if values:      
        for key in SETTINGS_KEYS_TO_ELEMENT_KEYS:  
            try:
                settings[key] = values[SETTINGS_KEYS_TO_ELEMENT_KEYS[key]]
            except Exception as e:
                print(f'Problem updating settings from window values. Key = {key}')

    with open(settings_file, 'w') as f:
        jsondump(settings, f)

    sg.popup('Settings saved')

def create_settings_window(settings):
    sg.theme(settings['theme'])

    def TextLabel(text): return sg.Text(text+':', justification='r', size=(15,1))

    layout = [  [sg.Text('Settings', font='Any 15')],
                [TextLabel('Theme'),sg.Combo(sg.theme_list(), size=(20, 20), key='-THEME-')],
                [sg.Button('Save'), sg.Button('Exit')]  ]

    window = sg.Window('Settings', layout, keep_on_top=True, finalize=True)

    for key in SETTINGS_KEYS_TO_ELEMENT_KEYS:
        try:
            window[SETTINGS_KEYS_TO_ELEMENT_KEYS[key]].update(value=settings[key])
        except Exception as e:
            print(f'Problem updating PySimpleGUI window from settings. Key = {key}')

    return window

def create_main_window(settings):
    sg.theme(settings['theme'])

    menu_def = [['&Menu', ['&Settings', 'E&xit']]]

    layout = [[sg.Menu(menu_def)],
              [sg.Text('Made by mizogg.co.uk Donations 3M6L77jC3jNejsd5ZU1CVpUVngrhanb6cD', size=(40,3), font=('Comic sans ms', 9)),
               sg.Text('Pick Vanity starts with address', size=(30,1), font=('Comic sans ms', 11)),
               sg.Input(size=(10,1), key='van'), sg.Text('', size=(17,1))],
               [sg.Button('', key='mizogg', size=(10,1), font=('Helvetica', 10), button_color=(sg.theme_background_color(), sg.theme_background_color()),
                         image_filename='mizogg.png', image_size=(400, 80), image_subsample=1, border_width=0),
               sg.Button('', key='face', size=(10,1), font=('Helvetica', 30), button_color=(sg.theme_background_color(), sg.theme_background_color()),
                         image_filename='MizoggFaceBW.png', image_size=(140, 80), image_subsample=1, border_width=0)],
              [sg.Text('MIZVAN.py - This program has been running for..................................... ', size=(56,1), font=('Comic sans ms', 12)),
               sg.Text('', size=(16,1), font=('Comic sans ms', 12), key='_DATE_')],
              [sg.Text('')],
              [sg.Output(size=(120, 20), font=('Comic sans ms', 9), key='out')],
              [sg.Button('Start/Stop',  font=('Comic sans ms', 12))]]

    return sg.Window('MIZOGG',
                     layout=layout,
                     default_element_size=(9,1))


def main():
    window, settings = None, load_settings(SETTINGS_FILE, DEFAULT_SETTINGS )
    generator = False
    while True:
        if window is None:
            window = create_main_window(settings)
        event, values = window.Read(timeout=10)
        window.Element('_DATE_').Update(str(datetime.datetime.now()-start_time))
        if event in (None, 'Exit'):
            break
        elif event == 'Start/Stop':
            generator = not generator
            count=0
            total=0
        if generator:
            add =values['van']
            ran= random.randint(1,115792089237316195423570985008687907852837564279074904382605163141518161494336)
            key = Key.from_int(ran)
            seed=str(ran)
            wif = bytes_to_wif(key.to_bytes(), compressed=False)
            wif2 = bytes_to_wif(key.to_bytes(), compressed=True)
            key1 = Key(wif)
            caddr = key.address #Legacy compressed address
            uaddr = key1.address #Legacy uncompressed address
            saddr = key.segwit_address  #Segwit address
            count+=1
            total+=3
            print (' PrivateKey (hex) : ' + str(key.to_hex()) + '\n' + ' PrivateKey (dec) : ' + str(seed) + '\n' + ' PrivateKey (wif) Compressed : ' + str(wif2) + '\n' + ' PrivateKey (wif) UnCompressed : ' + str(wif) + '\n' + ' <======================== Bitcoin Addresses Checked ========================>' + '\n' + "COMPRESSED   BTC:  " + str(caddr) + ' : ' + str(key.to_hex()) + '\n' + "UNCOMPRESSED BTC:  " + str(uaddr) + ' : ' + str(key1.to_hex()) + '\n' + "Segwit Address BTC:  " + str(saddr) + ' : ' + str(key.to_hex()) + '\n' + ' <======================== Bitcoin Addresses Checked ========================>' + '\n' + "Scan Number" + ' : ' + str (count) + ' : '+ "Total Wallets Checked" + ' : '  + str (total))
            if caddr.startswith(add) or uaddr.startswith(add) or saddr.startswith(add):
            
                contents1 = urllib.request.urlopen("https://blockchain.info/q/getreceivedbyaddress/" + caddr).read()
                contents2 = urllib.request.urlopen("https://blockchain.info/q/getreceivedbyaddress/" + uaddr).read()
                contents3 = urllib.request.urlopen("https://blockchain.info/q/getreceivedbyaddress/" + saddr).read()               
                print (' PrivateKey (hex) : ' + str(key.to_hex()) + '\n' + ' PrivateKey (dec) : ' + str(seed) + '\n' +
                ' PrivateKey (wif) Compressed : ' + str(wif2) + '\n' + ' PrivateKey (wif) UnCompressed : ' + str(wif) + '\n' + ' <======================== Bitcoin Addresses Checked for Total Received Ammount ========================>' + '\n' + "COMPRESSED   BTC:  " + str(caddr) + ' : ' + str(key.to_hex()) + ' : ' + str(contents1.decode('UTF8')) + '\n' + "UNCOMPRESSED BTC:  " + str(uaddr) + ' : ' + str(key1.to_hex()) + ' : ' + str(contents2.decode('UTF8')) + '\n' + "Segwit Address BTC:  " + str(saddr) + ' : ' + str(key.to_hex()) + ' : ' + str(contents3.decode('UTF8')) + '\n' + ' <======================== Bitcoin Addresses Checked for Total Received Ammount ========================>' + '\n' + "Scan Number" + ' : ' + str (count) + ' : '+ "Total Wallets Checked" + ' : '  + str (total))
                pass
        
                if int(contents1) > 0 or int(contents2) > 0 or int(contents3) > 0:
                    print (' <================== WINNER Total Received Ammount WINNER ==================>' + '\n' + 'Congraz you have found wallet with a balance : ' +  str(caddr) + ' : Balance : ' + str(contents1.decode('UTF8')) + '\n' + 'Congraz you have found wallet with a balance : ' +  str(uaddr)+ ' : Balance : ' + str(contents2.decode('UTF8')) + '\n' + 'Congraz you have found wallet with a balance : ' +  str(saddr)+ ' : Balance : ' + str(contents3.decode('UTF8')) + '\n' + ' PrivateKey (wif) Compressed : ' + str(wif2) + '\n' + ' PrivateKey (wif) UnCompressed : ' + str(wif) + '\n' + "\nMatching Key ==== Found!!!\n PrivateKey  (hex): " + str(key.to_hex()) + '\n' + "\nMatching Key ==== Found!!!\n PrivateKey  (dec): " + str(seed) + '\n' + ' <======================== WINNER Total Received Ammount WINNER ========================>' + '\n')
                    f=open(u"winner.txt","a")
                    f.write('\n=============Bitcoin Address with Total Received Ammount=====================')
                    f.write('\nPrivateKey (hex): ' + key.to_hex())
                    f.write('\nBitcoin Address Compressed : ' + caddr)
                    f.write('\nBitcoin Address UnCompressed :' + uaddr)
                    f.write('\nBitcoin Segwit Address :' + saddr)
                    f.write('\nPrivateKey (wif) Compressed : ' + wif2)
                    f.write('\nPrivateKey (wif) UnCompressed : ' + wif)
                    f.write('\n=============Bitcoin Address with Total Received Ammount=====================')
                    f.write('\n =====Made by mizogg.co.uk Donations 3M6L77jC3jNejsd5ZU1CVpUVngrhanb6cD =====' ) 
                    f.close()
        elif event == 'Settings':
            event, values = create_settings_window(settings).read(close=True)
            if event == 'Save':
                window.close()
                window = None
                save_settings(SETTINGS_FILE, settings, values)


        elif event == 'mizogg':
            webbrowser.open_new_tab("https://mizogg.co.uk")
        
        elif event == 'face':
            webbrowser.open_new_tab("https://mizogg.com")

    
    window.Close()
    
main()

